Subject: RE: [AVT] How is SDP a=fmtp used for RFC 2198?

From: "Mundra, Satish" <[email-masked]>
Date: Fri, 9 Apr 2004 14:17:52 -0400

Colin,

One more related question below...

> -----Original Message-----
> From: Colin Perkins [mailto:[email-masked]] 
> Sent: Friday, April 09, 2004 5:03 AM
> To: Mundra, Satish
> Cc: [email-masked]; Gunnar Hellstrom; Tim Melanchuk; 
> [email-masked]; [email-masked]
> Subject: Re: [AVT] How is SDP a=fmtp used for RFC 2198?
> 
> 
> On 8 Apr 2004, at 22:32, Mundra, Satish wrote:
> > Does this mean that if one wants to provide redundancy for 
> different 
> > encoding methods on "m=" line, one can not do so using a single RED 
> > PT?
> 
> Correct. The "a=fmtp:" lines tell the sender how to encode particular 
> data.
> 
> > See example below where redundancy is desired for both 97 and 98.
> >
> > m=audio 5678 RTP/AVP 0 97 98 99 100
> > a=rtpmap:97 telephone-event/8000
> > a=rtpmap:98 t140/8000
> > a=rtpmap:99 red/8000
> > a=rtpmap:100 red/8000
> > a=fmtp:99 97/97/97/97/97
> > a=fmtp:100 98/98/98
> 
> Sending this much redundancy is excessive, but the example is 
> syntactically correct.
> 

Another question:
----------------- 

The redundancy header fields "F" and "Block PT" enable a receiver to decode
the RED packet,
the level of redundancy, the PTs used for primary/secondary (and tertiary
etc.).  

For e.g.,
 
m=audio 5678 RTP/AVP 0 97 98 99 
a=rtpmap:97 telephone-event/8000
a=rtpmap:98 t140/8000
a=rtpmap:99 red/8000
a=fmtp:99 97/98

Any comination of 97 or 98 as primary/secondary/tertiary as payload for RED
can be 
decoded using the redundancy header fields. The largest possible RED packet
size (maximum redundancy levels allowed) can not be determined from above. 

Is "estimating the additional bandwidth" the motivation for specifying the
maximum redundancy levels for each primary and hence separate RED PTs ?

Satish Mundra

 

_______________________________________________
Audio/Video Transport Working Group
[email-masked]
https://www1.ietf.org/mailman/listinfo/avt

---

From: "Gunnar Hellstrom" <[email-masked]>
Date: Sun, 11 Apr 2004 07:32:00 +0200

I see an offer-answer consideration here:

If the offering side is cofigured to propose only one level of redundancy,
by
a=fmtp:99 98/98

and the answering side is in a network with a lot of loss, knowing that
three levels is needed for proper performance, it would respond:
a=fmtp:99 98/98/98/98

Both parties should then accept the highest redundancy level proposal for
its transmissions.

The general rule for offer/answer considerations for fmtp is according to
RFC 3264:
"The interpretation of fmtp parameters in an offer depends on the
   parameters.  In many cases, those parameters describe specific
   configurations of the media format, and should therefore be processed
   as the media format value itself would be.  This means that the same
   fmtp parameters with the same values MUST be present in the answer if
   the media format they describe is present in the answer.  Other fmtp
   parameters are more like parameters, for which it is perfectly
   acceptable for each agent to use different values.  In that case, the
   answer MAY contain fmtp parameters, and those MAY have the same
   values as those in the offer, or they MAY be different.  SDP
   extensions that define new parameters SHOULD specify the proper
   interpretation in offer/answer."

Thus, we are free to select a good principle for RFC2198 application and
describe it where sdp is described.

If this principle is accepted, it should be entered in either RFC2198,
draft-ietf-avt-text-red or  draft-ietf-avt-rfc2793bis.

For the text medium declared by m=text, I propose that it is placed in
draft-ietf-avt-text-red.

For audio media, it should have been in RFC2198. For the new text
packetization declared as audio/t140, the description MAY be placed in
draft-ietf-avt-rfc2793bis. Since it is a general concern, I do not feel it
is the exactly right place, and want to seek advice for where to put it.

Conclusion: I suggest that the sentence below is entered in the sdp
description of draft-ietf-avt-text-red for the text case, and await advice
for where to put it for the audio case:

"In an offer/answer situation, the fmtp parameter in the answer MAY
describe a different number of redundant levels than in the offer. The
session SHOULD use the highest number of redundant levels described."

Regards

Gunnar
-------------------------------------------
Gunnar Hellstrom
Omnitor AB
Renathvagen 2
SE 121 37 Johanneshov
SWEDEN
+46 8 556 002 03
Mob: +46 708 204 288
www.omnitor.se
[email-masked]
--------------------------------------------

> Sent: Saturday, April 10, 2004 1:08 PM
> To: Mundra, Satish
> On 9 Apr 2004, at 19:17, Mundra, Satish wrote:
> ...
> > Another question:
> > -----------------
> >
> > The redundancy header fields "F" and "Block PT" enable a receiver to
> > decode the RED packet, the level of redundancy, the PTs used for
> > primary/secondary (and tertiary etc.).
> >
> > For e.g.,
> >
> > Any comination of 97 or 98 as primary/secondary/tertiary as payload
> > for RED can be  decoded using the redundancy header fields. The
> > largest possible RED packet size (maximum redundancy levels allowed)
> > can not be determined from above.
> >
> > Is "estimating the additional bandwidth" the motivation for specifying
> > the maximum redundancy levels for each primary and hence separate RED
> > PTs ?
>
> No, the receiver can decode the data without this information. The
> "a=fmtp:" lines tell the sender what is required for the session. See
> RFC 2198 section 5.
>
> --
> Colin Perkins
> http://csperkins.org/
>
>
>

---

From: Colin Perkins <[email-masked]>
Date: Sat, 10 Apr 2004 12:07:47 +0100

-- 
Colin Perkins
http://csperkins.org/